/**
 * General settings.
 *
 * @package fwdmsp
 * @since fwdmsp 1.0
 */

jQuery(document).ready(function($){
  
  'use strict';
  
	var DEFAULT_SKINS_NR = 8;

  fwdmspSettingsAr = unescapeHtml(fwdmspSettingsAr);
  fwdmspSettingsAr = JSON.parse(fwdmspSettingsAr);
	
	var cur_settings_obj;
	
	$("#tabs").tabs();

  $("#visColor1, #visColor2, #visColor3, #visColor4, #visColor5, #visualizerCapColor, #atbTimeTextColorNormal, #atbTimeTextColorSelected, #atbButtonTextNormalColor, #atbButtonTextSelectedColor, #atbButtonBackgroundNormalColor, #atbButtonBackgroundSelectedColor,#borderColor, #scrubbersToolTipLabelBackgroundColor, #scrubbersToolTipLabelFontColor, #secondaryLabelsColor, #textColor, #inputBackgroundColor, #inputColor, #tooltips_button_font_color, #toolTipsButtonsBackgroundColor,#title_color, #normal_HEX_buttons_color, #normalHEXButtonsColor2, #playbackRateWindowTextColor, #time_color, #track_title_normal_color, #track_title_selected_color, #track_duration_color, #popup_window_background_color, #playlist_background_color, #search_input_color, #mainSelectorBackgroundSelectedColor, #mainSelectorTextNormalColor, #mainSelectorTextSelectedColor, #mainButtonTextNormalColor, #mainButtonTextSelectedColor").spectrum({
        color: "#5a5a5a",
        chooseText: "Update",
        showInitial: true,
        showInput: true,
        allowEmpty:false,
        preferredFormat: "hex6"
  });

  $("#tabs img").fwdTooltip({});  
 
	$("#start_space_between_buttons_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "startSpaceBetweenButtons.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
  $("#space_between_buttons_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "spaceBetweenButtons.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#separator_offset_out_space_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "separatorOffsetOutSpace.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#separator_offset_in_space_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "separatorOffsetInSpace.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#last_buttons_offset_top_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "lastButtonsOffsetTop.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#all_buttons_offset_top_and_bottom_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "allButtonsOffsetTopAndBottom.jpg' width='566' height='131'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#title_bar_offset_top_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "titleBarOffsetTop.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#main_scrubber_offset_top_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "mainScrubberOffsetTop.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img",
	});
	
	$("#space_between_main_scrubber_and_time_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "spaceBetweenMainScrubberAndTime.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#start_time_space_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "startTimeSpace.jpg' width='566' height='131'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#volume_button_and_scrubber_offset_top_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "volumeButtonAndScrubberOffsetTop.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#space_between_volume_button_and_scrubber_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "spaceBetweenVolumeButtonAndScrubber.jpg' width='748' height='71'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#scrubber_offset_bottom_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "scrubberOffsetBottom.jpg' width='566' height='131'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#track_title_offset_left_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "trackTitleOffsetLeft.jpg' width='750' height='32'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#play_pause_button_offset_left_and_right_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "playPauseButtonOffsetLeftAndRight.jpg' width='750' height='32'>",
		tooltipClass: "fwd-ui-tooltip-img"
	});
	
	$("#duration_offset_right_img").fwdTooltip({
		content: "<img src='" + fwdmspSpacesUrl + "durationOffsetRight.jpg' width='750' height='32'>",
		tooltipClass: "fwd-ui-tooltip-img",
	});


  // Set settings.
  function setSettings(){
    	var settings_obj = fwdmspSettingsAr[fwdmspCurOrderId];
    	
    	// Main settings
    	$("#name").val(settings_obj.name);
    	$("#skin_path").val(settings_obj.skin_path);
  		$("#show_soundcloud_username_in_title").val(settings_obj.show_soundcloud_username_in_title);
  		$("#use_youtube").val(settings_obj.use_youtube);
  		$("#use_video").val(settings_obj.use_video);
  		$("#show_next_and_prev_buttons").val(settings_obj.show_next_and_prev_buttons);
  		$("#use_HEX_colors_for_skin").val(settings_obj.use_HEX_colors_for_skin);
  		$("#showMainBackground").val(settings_obj.showMainBackground);
  		$("#addKeyboardSupport").val(settings_obj.addKeyboardSupport);
  		$("#useContinuousPlayback").val(settings_obj.useContinuousPlayback);
  		$("#show_full_screen_button").val(settings_obj.show_full_screen_button);
  		$("#defaultPlaybackRate").val(settings_obj.defaultPlaybackRate);
  		$("#verticalPosition").val(settings_obj.verticalPosition);
  		$("#horizontalPosition").val(settings_obj.horizontalPosition);
  		$("#use_deeplinking").val(settings_obj.use_deeplinking);
  		$("#right_click_context_menu").val(settings_obj.right_click_context_menu);
  		$("#show_buttons_tooltips").val(settings_obj.show_buttons_tooltips);
  		$("#animate").val(settings_obj.animate);
  		$("#autoplay").val(settings_obj.autoplay);
  		$("#loop").val(settings_obj.loop);
  		$("#shuffle").val(settings_obj.shuffle);
  		$("#start_at_random_track").val(settings_obj.start_at_random_track);
  		$("#max_width").val(settings_obj.max_width);
  		$("#volume").val(settings_obj.volume);
  		$("#tooltips_buttons_hide_delay").val(settings_obj.tooltips_buttons_hide_delay);
  		$("#tooltips_button_font_color").spectrum("set", settings_obj.tooltips_button_font_color != "transparent" ? settings_obj.tooltips_button_font_color : null);
      $("#toolTipsButtonsBackgroundColor").spectrum("set", settings_obj.toolTipsButtonsBackgroundColor != "transparent" ? settings_obj.toolTipsButtonsBackgroundColor : null);
    

  		// Controller settings.
  		$("#show_controller_by_default").val(settings_obj.show_controller_by_default);
      $("#useVectorIcons").val(settings_obj.useVectorIcons);
  		$("#show_thumbnail").val(settings_obj.show_thumbnail);
  		$("#disable_scrubber").val(settings_obj.disable_scrubber);
  		$("#playIfLoggedIn").val(settings_obj.playIfLoggedIn);
  		$("#loggedInMessage").val(unescapeHtml(settings_obj.loggedInMessage));
  		$("#show_loop_button").val(settings_obj.show_loop_button);
  		$("#show_shuffle_button").val(settings_obj.show_shuffle_button);
      $("#openPopupOnPlay").val(settings_obj.openPopupOnPlay);
  		$("#show_download_mp3_button").val(settings_obj.show_download_mp3_button);
  		$("#show_share_button").val(settings_obj.show_share_button);
  		$("#googleAnalyticsTrackingCode").val(settings_obj.googleAnalyticsTrackingCode);
      $("#proxyCors").val(settings_obj.proxyCors);
  		$("#soundCloudAPIKey").val(settings_obj.soundCloudAPIKey);
      $("#ytbAPiKey").val(settings_obj.ytbAPiKey);
  		$("#show_buy_button").val(settings_obj.show_buy_button);
  		$("#expand_background").val(settings_obj.expand_background);
  		$("#title_color").spectrum("set", settings_obj.title_color != "transparent" ? settings_obj.title_color : null);
  		$("#time_color").spectrum("set", settings_obj.time_color != "transparent" ? settings_obj.time_color : null);
  		$("#normal_HEX_buttons_color").spectrum("set", settings_obj.normal_HEX_buttons_color != "transparent" ? settings_obj.normal_HEX_buttons_color : null);
  		$("#playbackRateWindowTextColor").spectrum("set", settings_obj.playbackRateWindowTextColor != "transparent" ? settings_obj.playbackRateWindowTextColor : null);
  		$("#atbTimeTextColorNormal").spectrum("set", settings_obj.atbTimeTextColorNormal != "transparent" ? settings_obj.atbTimeTextColorNormal : null);
      $("#atbTimeTextColorSelected").spectrum("set", settings_obj.atbTimeTextColorSelected != "transparent" ? settings_obj.atbTimeTextColorSelected : null);
      $("#atbButtonTextNormalColor").spectrum("set", settings_obj.atbButtonTextNormalColor != "transparent" ? settings_obj.atbButtonTextNormalColor : null);
      $("#atbButtonTextSelectedColor").spectrum("set", settings_obj.atbButtonTextSelectedColor != "transparent" ? settings_obj.atbButtonTextSelectedColor : null);
     	$("#atbButtonBackgroundNormalColor").spectrum("set", settings_obj.atbButtonBackgroundNormalColor != "transparent" ? settings_obj.atbButtonBackgroundNormalColor : null);  
      $("#atbButtonBackgroundSelectedColor").spectrum("set", settings_obj.atbButtonBackgroundSelectedColor != "transparent" ? settings_obj.atbButtonBackgroundSelectedColor : null);    

      // Visualizer.
      $("#useVisualizer").val(settings_obj.useVisualizer);
      $("#visualizerRandomPreset").val(settings_obj.visualizerRandomPreset);
      $("#visualizerPreset").val(settings_obj.visualizerPreset);
      $("#visColor1").spectrum("set", settings_obj.visualizerColor[0]);
      $("#visColor2").spectrum("set", settings_obj.visualizerColor[1]);
      $("#visColor3").spectrum("set", settings_obj.visualizerColor[2]);
      $("#visColor4").spectrum("set", settings_obj.visualizerColor[3]);
      $("#visColor5").spectrum("set", settings_obj.visualizerColor[4]);
      $("#visualizerCapColor").spectrum("set", settings_obj.visualizerCapColor);

  		// Controller align and size settings.
  		$("#controller_height").val(settings_obj.controller_height);
  		$("#start_space_between_buttons").val(settings_obj.start_space_between_buttons);
  		$("#space_between_buttons").val(settings_obj.space_between_buttons);
  		$("#separator_offset_out_space").val(settings_obj.separator_offset_out_space);
  		$("#separator_offset_in_space").val(settings_obj.separator_offset_in_space);
  		$("#last_buttons_offset_top").val(settings_obj.last_buttons_offset_top);
  		$("#all_buttons_offset_top_and_bottom").val(settings_obj.all_buttons_offset_top_and_bottom);
  		$("#title_bar_offset_top").val(settings_obj.title_bar_offset_top);
  		$("#main_scrubber_offset_top").val(settings_obj.main_scrubber_offset_top);
  		$("#space_between_main_scrubber_and_time").val(settings_obj.space_between_main_scrubber_and_time);
  		$("#start_time_space").val(settings_obj.start_time_space);
  		$("#scrubbers_offset_width").val(settings_obj.scrubbers_offset_width);
  		$("#scrubbers_offset_total_width").val(settings_obj.scrubbers_offset_total_width);
  		$("#volume_button_and_scrubber_offset_top").val(settings_obj.volume_button_and_scrubber_offset_top);
  		$("#space_between_volume_button_and_scrubber").val(settings_obj.space_between_volume_button_and_scrubber);
  		$("#volume_scrubber_offset_width").val(settings_obj.volume_scrubber_offset_width);
  		$("#scrubber_offset_bottom").val(settings_obj.scrubber_offset_bottom);
      $("#playbackRateButtonsMargins").val(settings_obj.playbackRateButtonsMargins);

  		// Playlists window settings.
  		$("#show_playlists_button_and_playlists").val(settings_obj.show_playlists_button_and_playlists);
  		$("#showPlaylistsSelectBoxNumbers").val(settings_obj.showPlaylistsSelectBoxNumbers);
  		$("#usePlaylistsSelectBox").val(settings_obj.usePlaylistsSelectBox);
  		$("#playTrackAfterPlaylistLoad").val(settings_obj.playTrackAfterPlaylistLoad);
  		$("#show_playlists_by_default").val(settings_obj.show_playlists_by_default);
  		$("#thumbnail_selected_type").val(settings_obj.thumbnail_selected_type);
  		$("#showPlaylistsSearchInput").val(settings_obj.showPlaylistsSearchInput);
  		$("#start_at_playlist").val(settings_obj.start_at_playlist);
  		$("#start_at_track").val(settings_obj.start_at_track);
  		$("#buttons_margins").val(settings_obj.buttons_margins);
  		$("#thumbnail_max_width").val(settings_obj.thumbnail_max_width);
  		$("#thumbnail_max_height").val(settings_obj.thumbnail_max_height);
  		$("#horizontal_space_between_thumbnails").val(settings_obj.horizontal_space_between_thumbnails);
  		$("#vertical_space_between_thumbnails").val(settings_obj.vertical_space_between_thumbnails);
      $("#playlistSelectorHeight").val(settings_obj.playlistSelectorHeight);
  		$("#showPlaybackRateButton").val(settings_obj.showPlaybackRateButton);
  		$("#privatePassword").val(settings_obj.privatePassword);
  		$("#randomizePlaylist").val(settings_obj.randomizePlaylist);
  		$("#showMainScrubberAndVolumeScrubberToolTipLabel").val(settings_obj.showMainScrubberAndVolumeScrubberToolTipLabel);
		
  		// Playlist settings.
  		$("#show_playlist_button_and_playlist").val(settings_obj.show_playlist_button_and_playlist);
  		$("#showPlayListOnMobile").val(settings_obj.showPlayListOnMobile);
  		$("#show_playlist_by_default").val(settings_obj.show_playlist_by_default);
  		$("#show_playlist_item_play_button").val(settings_obj.show_playlist_item_play_button);
  		$("#show_playlist_item_download_button").val(settings_obj.show_playlist_item_download_button);
  		$("#show_playlist_item_buy_button").val(settings_obj.show_playlist_item_buy_button);
  		$("#force_disable_download_button_for_podcast").val(settings_obj.force_disable_download_button_for_podcast);
  		$("#force_disable_download_button_for_official_fm").val(settings_obj.force_disable_download_button_for_official_fm);
  		$("#force_disable_download_button_for_folder").val(settings_obj.force_disable_download_button_for_folder);
  		$("#add_scrollbar_mouse_wheel_support").val(settings_obj.add_scrollbar_mouse_wheel_support);
  		$("#show_tracks_numbers").val(settings_obj.show_tracks_numbers);
  		$("#playlist_background_color").spectrum("set", settings_obj.playlist_background_color != "transparent" ? settings_obj.playlist_background_color : null);
  		$("#track_title_normal_color").spectrum("set", settings_obj.track_title_normal_color != "transparent" ? settings_obj.track_title_normal_color : null);
  		$("#track_title_selected_color").spectrum("set", settings_obj.track_title_selected_color != "transparent" ? settings_obj.track_title_selected_color : null);
  		$("#track_duration_color").spectrum("set", settings_obj.track_duration_color != "transparent" ? settings_obj.track_duration_color : null);
  		$("#max_playlist_items").val(settings_obj.max_playlist_items);
      $("#playlistItemHeight").val(settings_obj.playlistItemHeight);
  		$("#nr_of_visible_playlist_items").val(settings_obj.nr_of_visible_playlist_items);
  		$("#track_title_offset_left").val(settings_obj.track_title_offset_left);
  		$("#play_pause_button_offset_left_and_right").val(settings_obj.play_pause_button_offset_left_and_right);
  		$("#duration_offset_right").val(settings_obj.duration_offset_right);
  		$("#download_button_offset_right").val(settings_obj.download_button_offset_right);
  		$("#scrollbar_offset_width").val(settings_obj.scrollbar_offset_width);

  		// Opener settings.
  		$("#show_opener").val(settings_obj.show_opener);
  		$("#opener_alignment").val(settings_obj.opener_alignment);
  		$("#show_opener").val(settings_obj.show_opener);
  		$("#show_opener_play_pause_button").val(settings_obj.show_opener_play_pause_button);
  		$("#opener_equlizer_offset_left").val(settings_obj.opener_equlizer_offset_left);
  		$("#opener_equlizer_offset_top").val(settings_obj.opener_equlizer_offset_top);
		
  		// Popup settings.
  		$("#show_popup_button").val(settings_obj.show_popup_button);
  		$("#popup_window_background_color").spectrum("set", settings_obj.popup_window_background_color != "transparent" ? settings_obj.popup_window_background_color : null);
  		$("#popup_window_width").val(settings_obj.popup_window_width);
  		$("#popup_window_height").val(settings_obj.popup_window_height);
		
  		// Search bar settings.
  		$("#show_search_bar").val(settings_obj.show_search_bar);
  		$("#show_sort_buttons").val(settings_obj.show_sort_buttons);
  		$("#search_input_color").spectrum("set", settings_obj.search_input_color != "transparent" ? settings_obj.search_input_color : null);
  		$("#mainSelectorBackgroundSelectedColor").spectrum("set", settings_obj.mainSelectorBackgroundSelectedColor != "transparent" ? settings_obj.mainSelectorBackgroundSelectedColor : null);
  		$("#mainSelectorTextNormalColor").spectrum("set", settings_obj.mainSelectorTextNormalColor != "transparent" ? settings_obj.mainSelectorTextNormalColor : null);
  		$("#mainSelectorTextSelectedColor").spectrum("set", settings_obj.mainSelectorTextSelectedColor != "transparent" ? settings_obj.mainSelectorTextSelectedColor : null);
  		$("#mainButtonTextNormalColor").spectrum("set", settings_obj.mainButtonTextNormalColor != "transparent" ? settings_obj.mainButtonTextNormalColor : null);
  		$("#mainButtonTextSelectedColor").spectrum("set", settings_obj.mainButtonTextSelectedColor != "transparent" ? settings_obj.mainButtonTextSelectedColor : null);
  		$("#borderColor").spectrum("set", settings_obj.borderColor != "transparent" ? settings_obj.borderColor : null);
  		$("#secondaryLabelsColor").spectrum("set", settings_obj.secondaryLabelsColor != "transparent" ? settings_obj.secondaryLabelsColor : null);
  		$("#textColor").spectrum("set", settings_obj.textColor != "transparent" ? settings_obj.textColor : null);
  		$("#inputBackgroundColor").spectrum("set", settings_obj.inputBackgroundColor != "transparent" ? settings_obj.inputBackgroundColor : null);
  		$("#inputColor").spectrum("set", settings_obj.inputColor != "transparent" ? settings_obj.inputColor : null);
  		$("#scrubbersToolTipLabelBackgroundColor").spectrum("set", settings_obj.scrubbersToolTipLabelBackgroundColor != "transparent" ? settings_obj.scrubbersToolTipLabelBackgroundColor : null);
  		$("#scrubbersToolTipLabelFontColor").spectrum("set", settings_obj.scrubbersToolTipLabelFontColor != "transparent" ? settings_obj.scrubbersToolTipLabelFontColor : null);
  		$("#search_bar_height").val(settings_obj.search_bar_height);
  		$("#input_search_text_offset_top").val(settings_obj.input_search_text_offset_top);
  		$("#input_search_offset_left").val(settings_obj.input_search_offset_left);
  }


  // Initialize.
  function init(){   
    	$.each(fwdmspSettingsAr, function(i, el){
          $("#skins").append("<option value='" + el.id + "'>" + el.name + "</option>");
		  });
    	
    	$("#skins").val(fwdmspSetId);
    	
    	if (fwdmspCurOrderId < DEFAULT_SKINS_NR){
    		  $("#update_btn").hide();
          $("#del_btn").hide();
    	}else{
    		  $("#update_btn").show();
          $("#del_btn").show();
    	}
	    
	    setSettings();
	    $("#preset_id").html("ID : " + fwdmspSetId);
	    $("#tabs").tabs("option", "active", fwdmspTabInitId);
  }
    
  init();
    
  $("#skins").change(function(){
    	fwdmspSetId = parseInt($("#skins").val());
    	
    	$.each(fwdmspSettingsAr, function(i, el){
			if (fwdmspSetId == el.id){
				  fwdmspCurOrderId = i;
			}
	});  	
  setSettings();
    	
  if (fwdmspCurOrderId < DEFAULT_SKINS_NR){
    	$("#update_btn").hide();
      $("#del_btn").hide();
  }else{
    	$("#update_btn").show();
      $("#del_btn").show();
  }
    	
  allFields.removeClass("ui-state-error");
    	$("#tips").text("All form fields are required.");
    	
    	$("#preset_id").html("ID : " + fwdmspSetId);
  });
  

  // Update settings.  
  function updateSettings(){

  		// Main settings.
      cur_settings_obj.id = fwdmspSetId;
      cur_settings_obj.name = $("#name").val().replace(/"/g, "'");
      cur_settings_obj.skin_path = $("#skin_path").val();
  		cur_settings_obj.show_soundcloud_username_in_title = $("#show_soundcloud_username_in_title").val();
  		cur_settings_obj.use_youtube = $("#use_youtube").val();
  		cur_settings_obj.use_video = $("#use_video").val();
  		cur_settings_obj.show_next_and_prev_buttons = $("#show_next_and_prev_buttons").val();
  		cur_settings_obj.use_HEX_colors_for_skin = $("#use_HEX_colors_for_skin").val();
  		cur_settings_obj.showMainBackground = $("#showMainBackground").val();
  		cur_settings_obj.addKeyboardSupport = $("#addKeyboardSupport").val();
  		cur_settings_obj.useContinuousPlayback = $("#useContinuousPlayback").val();		
  		cur_settings_obj.show_full_screen_button = $("#show_full_screen_button").val();
  		cur_settings_obj.defaultPlaybackRate = $("#defaultPlaybackRate").val();
  		cur_settings_obj.verticalPosition = $("#verticalPosition").val();
  		cur_settings_obj.horizontalPosition = $("#horizontalPosition").val();
  		cur_settings_obj.use_deeplinking = $("#use_deeplinking").val();
  		cur_settings_obj.right_click_context_menu = $("#right_click_context_menu").val();
  		cur_settings_obj.show_buttons_tooltips = $("#show_buttons_tooltips").val();
  		cur_settings_obj.animate = $("#animate").val();
  		cur_settings_obj.autoplay = $("#autoplay").val();
  		cur_settings_obj.loop = $("#loop").val();
  		cur_settings_obj.shuffle = $("#shuffle").val();
  		cur_settings_obj.start_at_random_track = $("#start_at_random_track").val();
  		cur_settings_obj.max_width = parseInt($("#max_width").val());
  		cur_settings_obj.volume = parseFloat($("#volume").val());
  		cur_settings_obj.tooltips_buttons_hide_delay = parseFloat($("#tooltips_buttons_hide_delay").val());
  		cur_settings_obj.tooltips_button_font_color = $("#tooltips_button_font_color").spectrum("get") ? $("#tooltips_button_font_color").spectrum("get").toHexString() : "transparent";
      cur_settings_obj.toolTipsButtonsBackgroundColor = $("#toolTipsButtonsBackgroundColor").spectrum("get") ? $("#toolTipsButtonsBackgroundColor").spectrum("get").toHexString() : "transparent";

  		// Controller settings.
  		cur_settings_obj.show_controller_by_default = $("#show_controller_by_default").val();
      cur_settings_obj.useVectorIcons = $("#useVectorIcons").val();
  		cur_settings_obj.show_thumbnail = $("#show_thumbnail").val();
  		cur_settings_obj.disable_scrubber = $("#disable_scrubber").val();
  		cur_settings_obj.playIfLoggedIn = $("#playIfLoggedIn").val();
  		cur_settings_obj.loggedInMessage = $("#loggedInMessage").val().replace(/"/g, "'");
  		cur_settings_obj.show_loop_button = $("#show_loop_button").val();
  		cur_settings_obj.show_shuffle_button = $("#show_shuffle_button").val();
      cur_settings_obj.openPopupOnPlay = $("#openPopupOnPlay").val();
  		cur_settings_obj.show_download_mp3_button = $("#show_download_mp3_button").val();
  		cur_settings_obj.show_share_button = $("#show_share_button").val();
  		cur_settings_obj.googleAnalyticsTrackingCode = $("#googleAnalyticsTrackingCode").val().replace(/"/g, "'");
      cur_settings_obj.proxyCors = $("#proxyCors").val().replace(/"/g, "'");
  		cur_settings_obj.soundCloudAPIKey = $("#soundCloudAPIKey").val();
      cur_settings_obj.ytbAPiKey = $("#ytbAPiKey").val().replace(/"/g, "'");
  		cur_settings_obj.show_buy_button = $("#show_buy_button").val();
  		cur_settings_obj.expand_background = $("#expand_background").val();
  		cur_settings_obj.title_color = $("#title_color").spectrum("get") ? $("#title_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.time_color = $("#time_color").spectrum("get") ? $("#time_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.normal_HEX_buttons_color = $("#normal_HEX_buttons_color").spectrum("get") ? $("#normal_HEX_buttons_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.playbackRateWindowTextColor = $("#playbackRateWindowTextColor").spectrum("get") ? $("#playbackRateWindowTextColor").spectrum("get").toHexString() : "transparent";

  		// Controller align and size settings.
  		cur_settings_obj.controller_height = parseInt($("#controller_height").val());
  		cur_settings_obj.start_space_between_buttons = parseInt($("#start_space_between_buttons").val());
  		cur_settings_obj.space_between_buttons = parseInt($("#space_between_buttons").val());
  		cur_settings_obj.separator_offset_out_space = parseInt($("#separator_offset_out_space").val());
  		cur_settings_obj.separator_offset_in_space = parseInt($("#separator_offset_in_space").val());
  		cur_settings_obj.last_buttons_offset_top = parseInt($("#last_buttons_offset_top").val());
  		cur_settings_obj.all_buttons_offset_top_and_bottom = parseInt($("#all_buttons_offset_top_and_bottom").val());
  		cur_settings_obj.title_bar_offset_top = parseInt($("#title_bar_offset_top").val());
  		cur_settings_obj.main_scrubber_offset_top = parseInt($("#main_scrubber_offset_top").val());
  		cur_settings_obj.space_between_main_scrubber_and_time = parseInt($("#space_between_main_scrubber_and_time").val());
  		cur_settings_obj.start_time_space = parseInt($("#start_time_space").val());
  		cur_settings_obj.scrubbers_offset_width = parseInt($("#scrubbers_offset_width").val());
  		cur_settings_obj.scrubbers_offset_total_width = parseInt($("#scrubbers_offset_total_width").val());
  		cur_settings_obj.volume_button_and_scrubber_offset_top = parseInt($("#volume_button_and_scrubber_offset_top").val());
  		cur_settings_obj.space_between_volume_button_and_scrubber = parseInt($("#space_between_volume_button_and_scrubber").val());
  		cur_settings_obj.volume_scrubber_offset_width = parseInt($("#volume_scrubber_offset_width").val());
  		cur_settings_obj.scrubber_offset_bottom = parseInt($("#scrubber_offset_bottom").val());
      cur_settings_obj.playbackRateButtonsMargins = parseInt($("#playbackRateButtonsMargins").val());
      
  		// Playlists window settings.
  		cur_settings_obj.show_playlists_button_and_playlists = $("#show_playlists_button_and_playlists").val();
  		cur_settings_obj.showPlaylistsSelectBoxNumbers = $("#showPlaylistsSelectBoxNumbers").val();
  		cur_settings_obj.usePlaylistsSelectBox = $("#usePlaylistsSelectBox").val();
  		cur_settings_obj.playTrackAfterPlaylistLoad = $("#playTrackAfterPlaylistLoad").val();
  		cur_settings_obj.show_playlists_by_default = $("#show_playlists_by_default").val();
  		cur_settings_obj.thumbnail_selected_type = $("#thumbnail_selected_type").val();
  		cur_settings_obj.showPlaylistsSearchInput = $("#showPlaylistsSearchInput").val();
  		cur_settings_obj.start_at_playlist = parseInt($("#start_at_playlist").val());
  		cur_settings_obj.start_at_track = parseInt($("#start_at_track").val());
  		cur_settings_obj.buttons_margins = parseInt($("#buttons_margins").val());
  		cur_settings_obj.thumbnail_max_width = parseInt($("#thumbnail_max_width").val());
  		cur_settings_obj.thumbnail_max_height = parseInt($("#thumbnail_max_height").val());
  		cur_settings_obj.horizontal_space_between_thumbnails = parseInt($("#horizontal_space_between_thumbnails").val());
  		cur_settings_obj.vertical_space_between_thumbnails = parseInt($("#vertical_space_between_thumbnails").val());
      cur_settings_obj.playlistSelectorHeight = parseInt($("#playlistSelectorHeight").val());
  		cur_settings_obj.showPlaybackRateButton = $("#showPlaybackRateButton").val();
  		cur_settings_obj.privatePassword = $("#privatePassword").val().replace(/"/g, "'");
  		cur_settings_obj.randomizePlaylist = $("#randomizePlaylist").val();
  		cur_settings_obj.showMainScrubberAndVolumeScrubberToolTipLabel = $("#showMainScrubberAndVolumeScrubberToolTipLabel").val();
  		
  		// playlist settings.
  		cur_settings_obj.show_playlist_button_and_playlist = $("#show_playlist_button_and_playlist").val();
  		cur_settings_obj.showPlayListOnMobile = $("#showPlayListOnMobile").val();
  		cur_settings_obj.show_playlist_by_default = $("#show_playlist_by_default").val();
  		cur_settings_obj.show_playlist_item_play_button = $("#show_playlist_item_play_button").val();
  		cur_settings_obj.show_playlist_item_download_button = $("#show_playlist_item_download_button").val();
  		cur_settings_obj.show_playlist_item_buy_button = $("#show_playlist_item_buy_button").val();
  		cur_settings_obj.force_disable_download_button_for_podcast = $("#force_disable_download_button_for_podcast").val();
  		cur_settings_obj.force_disable_download_button_for_official_fm = $("#force_disable_download_button_for_official_fm").val();
  		cur_settings_obj.force_disable_download_button_for_folder = $("#force_disable_download_button_for_folder").val();
  		cur_settings_obj.add_scrollbar_mouse_wheel_support = $("#add_scrollbar_mouse_wheel_support").val();
  		cur_settings_obj.show_tracks_numbers = $("#show_tracks_numbers").val();
      cur_settings_obj.playlistItemHeight = parseInt($("#playlistItemHeight").val());
  		cur_settings_obj.playlist_background_color = $("#playlist_background_color").spectrum("get") ? $("#playlist_background_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.track_title_normal_color = $("#track_title_normal_color").spectrum("get") ? $("#track_title_normal_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.track_title_selected_color = $("#track_title_selected_color").spectrum("get") ? $("#track_title_selected_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.track_duration_color = $("#track_duration_color").spectrum("get") ? $("#track_duration_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.max_playlist_items = parseInt($("#max_playlist_items").val());
  		cur_settings_obj.nr_of_visible_playlist_items = parseInt($("#nr_of_visible_playlist_items").val());
  		cur_settings_obj.track_title_offset_left = parseInt($("#track_title_offset_left").val());
  		cur_settings_obj.play_pause_button_offset_left_and_right = parseInt($("#play_pause_button_offset_left_and_right").val());
  		cur_settings_obj.duration_offset_right = parseInt($("#duration_offset_right").val());
  		cur_settings_obj.download_button_offset_right = parseInt($("#download_button_offset_right").val());
  		cur_settings_obj.scrollbar_offset_width = parseInt($("#scrollbar_offset_width").val());

  		// Opener settings.
  		cur_settings_obj.opener_alignment = $("#opener_alignment").val();
  		cur_settings_obj.show_opener = $("#show_opener").val();
  		cur_settings_obj.show_opener_play_pause_button = $("#show_opener_play_pause_button").val();
  		cur_settings_obj.opener_equlizer_offset_left = parseInt($("#opener_equlizer_offset_left").val());
  		cur_settings_obj.opener_equlizer_offset_top = parseInt($("#opener_equlizer_offset_top").val());
  		
  		// Popup settings.
  		cur_settings_obj.show_popup_button = $("#show_popup_button").val();
  		cur_settings_obj.popup_window_background_color = $("#popup_window_background_color").spectrum("get") ? $("#popup_window_background_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.popup_window_width = parseInt($("#popup_window_width").val());
  		cur_settings_obj.popup_window_height = parseInt($("#popup_window_height").val());
  		
  		// Search bar settings.
  		cur_settings_obj.show_search_bar = $("#show_search_bar").val();
  		cur_settings_obj.show_sort_buttons = $("#show_sort_buttons").val();
  		cur_settings_obj.search_input_color = $("#search_input_color").spectrum("get") ? $("#search_input_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.mainSelectorBackgroundSelectedColor = $("#mainSelectorBackgroundSelectedColor").spectrum("get") ? $("#mainSelectorBackgroundSelectedColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.mainSelectorTextNormalColor = $("#mainSelectorTextNormalColor").spectrum("get") ? $("#mainSelectorTextNormalColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.mainSelectorTextSelectedColor = $("#mainSelectorTextSelectedColor").spectrum("get") ? $("#mainSelectorTextSelectedColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.mainButtonTextNormalColor = $("#mainButtonTextNormalColor").spectrum("get") ? $("#mainButtonTextNormalColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.mainButtonTextSelectedColor = $("#mainButtonTextSelectedColor").spectrum("get") ? $("#mainButtonTextSelectedColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.borderColor = $("#borderColor").spectrum("get") ? $("#borderColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.secondaryLabelsColor = $("#secondaryLabelsColor").spectrum("get") ? $("#secondaryLabelsColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.textColor = $("#textColor").spectrum("get") ? $("#textColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.inputBackgroundColor = $("#inputBackgroundColor").spectrum("get") ? $("#inputBackgroundColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.inputColor = $("#inputColor").spectrum("get") ? $("#inputColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.scrubbersToolTipLabelBackgroundColor = $("#scrubbersToolTipLabelBackgroundColor").spectrum("get") ? $("#scrubbersToolTipLabelBackgroundColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.scrubbersToolTipLabelFontColor = $("#scrubbersToolTipLabelFontColor").spectrum("get") ? $("#scrubbersToolTipLabelFontColor").spectrum("get").toHexString() : "transparent";
      cur_settings_obj.atbTimeTextColorNormal = $("#atbTimeTextColorNormal").spectrum("get") ? $("#atbTimeTextColorNormal").spectrum("get").toHexString() : "transparent";
  	  cur_settings_obj.atbTimeTextColorSelected = $("#atbTimeTextColorSelected").spectrum("get") ? $("#atbTimeTextColorSelected").spectrum("get").toHexString() : "transparent";
  	  cur_settings_obj.atbButtonTextNormalColor = $("#atbButtonTextNormalColor").spectrum("get") ? $("#atbButtonTextNormalColor").spectrum("get").toHexString() : "transparent";
  	  cur_settings_obj.atbButtonTextSelectedColor = $("#atbButtonTextSelectedColor").spectrum("get") ? $("#atbButtonTextSelectedColor").spectrum("get").toHexString() : "transparent";
  	  cur_settings_obj.atbButtonBackgroundNormalColor = $("#atbButtonBackgroundNormalColor").spectrum("get") ? $("#atbButtonBackgroundNormalColor").spectrum("get").toHexString() : "transparent";
  	  cur_settings_obj.atbButtonBackgroundSelectedColor = $("#atbButtonBackgroundSelectedColor").spectrum("get") ? $("#atbButtonBackgroundSelectedColor").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.search_bar_height = parseInt($("#search_bar_height").val());
  		cur_settings_obj.input_search_text_offset_top = parseInt($("#input_search_text_offset_top").val());
  		cur_settings_obj.input_search_offset_left = parseInt($("#input_search_offset_left").val());

      // Visualizer.
      cur_settings_obj.useVisualizer = $("#useVisualizer").val();
      cur_settings_obj.visualizerRandomPreset = $("#visualizerRandomPreset").val();
      cur_settings_obj.visualizerPreset = $("#visualizerPreset").val();

      var clrs = [$("#visColor1").spectrum("get").toHexString(),
                    $("#visColor2").spectrum("get").toHexString(),
                    $("#visColor3").spectrum("get").toHexString(),
                    $("#visColor4").spectrum("get").toHexString(),
                    $("#visColor5").spectrum("get").toHexString()];
      cur_settings_obj.visualizerColor = clrs;
      cur_settings_obj.visualizerCapColor = $("#visualizerCapColor").spectrum("get").toHexString()
  }
    
  function checkLength(el, prop, min, max){
     	if ((el.val().length > max) || (el.val().length < min)){
        	el.addClass("ui-state-error");
        	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
        	
        	return false;
      }else{
        	return true;
      }
	}
    
  function checkIfIntegerAndLength(el, prop, min, max){
    	var int_reg_exp = /-?[0-9]+/;
    	var str = el.val();
    	var res = str.match(int_reg_exp);
    	
    	if (res && (res[0] == str)){
    		  if ((el.val().length > max) || (el.val().length < min)){
              el.addClass("ui-state-error");
              updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
            	return false;
          }else{
            	return true;
          }
      }else{
      	el.addClass("ui-state-error");
      	updateTips("The " + prop + " field value must be an integer.");
      	
      	return false;
      }
	}
    
  function checkIfFloatAndLength(el, prop, min, max){
    	var float_reg_exp = /1\.0|0?\.[0-9]+|[01]/;
    	var str = el.val();
    	var res = str.match(float_reg_exp);
    	
    	if (res && (res[0] == str)){
    		  if ((el.val().length > max) || (el.val().length < min)){
            	el.addClass("ui-state-error");
            	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
            	
            	return false;
          }else{
            	return true;
          }
      }else{
        	el.addClass("ui-state-error");
        	updateTips("The " + prop + " field value must be a float number.");
        	return false;
      }
	}
	
  function checkIfFloatAndLength2(el, prop, min, max){
    	var float_reg_exp = /[0-9]*\.?[0-9]+/;
    	var str = el.val();
    	var res = str.match(float_reg_exp);
    	
    	if(res && (res[0] == str)){
    	   if ((el.val().length > max) || (el.val().length < min)){
            	el.addClass("ui-state-error");
            	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
            	
            	return false;
          	}else{
            	return true;
            }
      }else{
        	el.addClass("ui-state-error");
        	updateTips("The " + prop + " field value must be a float number.");
        	
        	return false;
      }
	}

	function updateTips(txt){
		  $("#tips").text(txt).addClass("ui-state-highlight");

	    setTimeout(function(){
	    	$("#tips").removeClass("ui-state-highlight", 1500);
	    }, 500);
	    
	    $("#tips").addClass("fwd-error");
	}
	
	var allFields = $([]).add($("#name")).add($("#max_width")).add($("#volume")).add($("#privatePassword")).add($("#tooltips_buttons_hide_delay")).add($("#defaultPlaybackRate")).add($("#controller_height")).add($("#start_space_between_buttons"))
	 					  .add($("#space_between_buttons")).add($("#separator_offset_out_space")).add($("#separator_offset_in_space")).add($("#last_buttons_offset_top"))
	 					  .add($("#all_buttons_offset_top_and_bottom")).add($("#title_bar_offset_top")).add($("#main_scrubber_offset_top")).add($("#space_between_main_scrubber_and_time")).add($("#start_time_space"))
						  .add($("#scrubbers_offset_width")).add($("#scrubbers_offset_total_width")).add($("#volume_button_and_scrubber_offset_top")).add($("#space_between_volume_button_and_scrubber"))
						  .add($("#volume_scrubber_offset_width")).add($("#scrubber_offset_bottom")).add($("#playbackRateButtonsMargins")).add($("#start_at_playlist")).add($("#start_at_track")).add($("#buttons_margins"))
						  .add($("#thumbnail_max_width")).add($("#thumbnail_max_height")).add($("#horizontal_space_between_thumbnails")).add($("#vertical_space_between_thumbnails")).add($("#playlistSelectorHeight")).add($("#playlistItemHeight")).add($("#max_playlist_items"))
						  .add($("#nr_of_visible_playlist_items")).add($("#track_title_offset_left")).add($("#play_pause_button_offset_left_and_right")).add($("#duration_offset_right")).add($("#download_button_offset_right"))
						  .add($("#scrollbar_offset_width")).add($("#opener_equlizer_offset_left")).add($("#opener_equlizer_offset_top")).add($("#popup_window_width")).add($("#popup_window_height")).add($("#search_bar_height"))
						  .add($("#input_search_text_offset_top")).add($("#input_search_offset_left"));
	var fValid = false;
	

  // Validate inputs. 
  function validateFields(){
		  fValid = true;
     	
      allFields.removeClass("ui-state-error");

      // Main settings.
      fValid = fValid && checkLength($("#name"), "name", 1, 64);
      fValid = fValid && checkIfIntegerAndLength($("#max_width"), "maximum width", 1, 8);
      fValid = fValid && checkIfFloatAndLength($("#volume"), "volume", 1, 8);
      fValid = fValid && checkLength($("#privatePassword"), "global private tracks password ", 1, 80);
      fValid = fValid && checkIfFloatAndLength2($("#tooltips_buttons_hide_delay"), "tooltips buttons hide delay", 1, 8);
      fValid = fValid && checkIfFloatAndLength2($("#defaultPlaybackRate"), "default track playback rate /speed", 1, 3);
		
      if (!fValid){
      		$("#tabs").tabs("option", "active", 0);
      		window.scrollTo(0,0);
      		return false;
      }
      	
    	// Cntroller align and size settings.
    	fValid = fValid && checkIfIntegerAndLength($("#controller_height"), "controller height", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#start_space_between_buttons"), "start space between buttons", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#space_between_buttons"), "space between buttons", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#separator_offset_out_space"), "separator offset out space", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#separator_offset_in_space"), "separator offset in space", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#last_buttons_offset_top"), "last buttons offset top", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#all_buttons_offset_top_and_bottom"), "all buttons offset top and bottom", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#title_bar_offset_top"), "title bar offset top", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#main_scrubber_offset_top"), "main scrubber offset top", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#space_between_main_scrubber_and_time"), "space between main scrubber and time", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#start_time_space"), "start time space", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#scrubbers_offset_width"), "scrubbers offset width", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#scrubbers_offset_total_width"), "scrubbers offset total width", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#volume_button_and_scrubber_offset_top"), "volume button and scrubber offset top", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#space_between_volume_button_and_scrubber"), "space between volume button and scrubber", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#volume_scrubber_offset_width"), "volume scrubber offset width", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#scrubber_offset_bottom"), "scrubber offset bottom", 1, 8);
      fValid = fValid && checkIfIntegerAndLength($("#playbackRateButtonsMargins"), "close button offest top and right", 1, 3);
    	
    	if (!fValid){
    		  $("#tabs").tabs("option", "active", 2);
    		  window.scrollTo(0,0);
    		  return false;
    	}
      	
    	// Playlists window settings settings.
    	fValid = fValid && checkIfIntegerAndLength($("#start_at_playlist"), "start at playlist", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#start_at_track"), "start at track", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#buttons_margins"), "buttons margins", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#thumbnail_max_width"), "thumbnail maximum width", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#thumbnail_max_height"), "thumbnail maximum height", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#horizontal_space_between_thumbnails"), "horizontal space between thumbnails", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#vertical_space_between_thumbnails"), "vertical space between thumbnails", 1, 8);
      fValid = fValid && checkIfIntegerAndLength($("#playlistSelectorHeight"), "combo-box selector height", 1, 2);
    	
    	if (!fValid){
    		  $("#tabs").tabs("option", "active", 3);
    		  window.scrollTo(0,0);
    		  return false;
    	}
      	
    	// Playlist settings.
      fValid = fValid && checkIfIntegerAndLength($("#playlistItemHeight"), "playlist item height", 1, 2);
  	  fValid = fValid && checkIfIntegerAndLength($("#max_playlist_items"), "maximum playlist items", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#nr_of_visible_playlist_items"), "number of visible playlist items", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#track_title_offset_left"), "track title offset left", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#play_pause_button_offset_left_and_right"), "play pause button offset left and right", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#duration_offset_right"), "duration offset right", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#download_button_offset_right"), "download button offset right", 1, 8);
  	  fValid = fValid && checkIfIntegerAndLength($("#scrollbar_offset_width"), "scrollbar offset width", 1, 8);
    	
    	if (!fValid){
      		$("#tabs").tabs("option", "active", 4);
      		window.scrollTo(0,0);
      		return false;
    	}
      	
      // Opener settings.
    	fValid = fValid && checkIfIntegerAndLength($("#opener_equlizer_offset_left"), "opener equalizer offset left", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#opener_equlizer_offset_top"), "opener equalizer offset top", 1, 8);
      	
    	if (!fValid){
      		$("#tabs").tabs("option", "active", 5);
      		window.scrollTo(0,0);
      		return false;
    	}
		
		  // popup settings
    	fValid = fValid && checkIfIntegerAndLength($("#popup_window_width"), "popup window width", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#popup_window_height"), "popup window height", 1, 8);
      	
      if (!fValid){
      		$("#tabs").tabs("option", "active", 6);
      		window.scrollTo(0,0);
      		return false;
      }
		
  		// search bar settings
    	fValid = fValid && checkIfIntegerAndLength($("#search_bar_height"), "search bar height", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#input_search_text_offset_top"), "input search text offset top", 1, 8);
    	fValid = fValid && checkIfIntegerAndLength($("#input_search_offset_left"), "input search offset left", 1, 8);
      	
      if (!fValid){
      		$("#tabs").tabs("option", "active", 7);
      		window.scrollTo(0,0);
      		return false;
      }
	}
  

  // Add presets.  
  $("#add_btn").click(function(e){
    	validateFields();

      if (fValid){
      		cur_settings_obj = {};
        	
        	fwdmspSetId = $("#skins option").length;
        	fwdmspCurOrderId = $("#skins option").length;
        	
      		var idsAr = [];
      		
      		if (fwdmspSetId > DEFAULT_SKINS_NR){
      		    $.each(fwdmspSettingsAr, function(i, el){
    				      idsAr.push(el.id);
    			    });

          		for (var i=DEFAULT_SKINS_NR; i<fwdmspSettingsAr.length; i++){
          		  if ($.inArray(i, idsAr) == -1){
          				  fwdmspSetId = i;
          				  break;
          		  }
         		 }
      	   }
        	
	    	  updateSettings();
	    	
	    	  fwdmspSettingsAr.push(cur_settings_obj);
	    	
  	    	var data_obj ={
    	    		action: "add",
    	    		set_id: fwdmspSetId,
    	    		set_order_id: fwdmspCurOrderId,
    	    		tab_init_id: $("#tabs").tabs("option", "active"),
    	    		settings_ar: fwdmspSettingsAr
  	    	};
	    	
	    	  $("#settings_data").val(JSON.stringify(data_obj));
      }else{
      		return false;
      }
  });
  

  // Update preset.  
  $("#update_btn").click(function(){
    	validateFields();

      if (fValid){
      		cur_settings_obj = {};
	    	  updateSettings();
	    	  fwdmspSettingsAr[fwdmspCurOrderId] = cur_settings_obj;
	    	
  	    	var data_obj ={
    	    		action: "save",
    	    		set_id: fwdmspSetId,
    	    		set_order_id: fwdmspCurOrderId,
    	    		tab_init_id: $("#tabs").tabs("option", "active"),
    	    		settings_ar: fwdmspSettingsAr
  	    	};
	    	
  	    	$("#settings_data").val(JSON.stringify(data_obj));
      }else{
       		return false;
      }
  });
  

  // Delete preset.  
  $("#del_btn").click(function(){
    	fwdmspSettingsAr.splice(fwdmspCurOrderId, 1);
    	
    	var data_obj ={
      		action: "del",
      		settings_ar: fwdmspSettingsAr
    	};
    	
    	$("#settings_data").val(JSON.stringify(data_obj));
  });


  // Utils.
  function escapeHtml(str) {
      var map = {
          "&": "&amp;",
          "<": "&lt;",
          ">": "&gt;",
          "\"": "&quot;",
          "'": "&#039;"
      };
      str = str.replace(/'/g, "\"");
      return str.replace(/[&<>"']/g, function(m) { return map[m]; });
  }

  function unescapeHtml(str) {
      var map = {
          "&amp;": "&",
          "&lt;": "<",
          "&gt;": ">",
          "&quot;": "\"",
          "&#039;": "'"
      };
      return str.replace(/(&amp;|&lt;|&gt;|&quot;|&#039;)/g, function(m) { return map[m]; });
  }

  function removeFirstAndLastChar(str){
      str = str.substring(1);
      str = str.slice(0, -1);
      return str;
  }
});